; loochlisp -- RTcmix/gcl demo program.  This requires the "bradhacks"
; modifications to gcl-2.2.2 to run, plus it needs the "init.lsp" and
; "utils.lisp" files also included here.

; run by saying  "gcl < loochlisp.lsp" if all is set up...
; BGG


(setq pitches '(7.00 7.02 7.07 7.10 8.00 8.02 8.03 8.05 8.07 8.10 9.00 9.02))

(defun loochlisp() (prog(pitch slp)
	(system "CMIX -i -n &")
	(sleep 3)
	(setq ss (rtcmix-socket-open "localhost" 1102))
	(rtcmix-print "rtsetparams" '(22050 2) ss)
	(rtcmix-print "load" '("WAVETABLE") ss)
	(rtcmix-print "makegen" '(1 10 1000 1 0.2 0.1) ss)
	(rtcmix-print "makegen" '(2 24 1000 0 0 1 1 2 0) ss)
	(setq slp 0)
again
	(setq pitch (getel pitches))
	(rtcmix-print "WAVETABLE" `(0 7 7000 ,pitch 0) ss)
	(rtcmix-print "WAVETABLE" `(0 7 7000 ,(+ pitch (frandom 0.002)) 0.5) ss)
	(rtcmix-print "WAVETABLE" `(0 7 7000 ,(+ pitch (frandom 0.002)) 1) ss)
	(setq slp (const-frandom 1.0 4.0))
	(rtcmix-timer slp)
	(go again)
	)
)


(loochlisp)
